#pragma once

#include "NPCommonUI.h"
#include <GdiPlus.h>

#define	DECLARE_MESSAGE_HANDLER(_x_)	virtual LRESULT _x_(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
#define	DECLARE_COMMAND_HANDLER(_x_)	virtual LRESULT _x_(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL &bHandled)
#define DECLARE_NOTIFY_HANDLER(_x_)		virtual LRESULT _x_(int, NMHDR *, BOOL &)

#define	IMPLEMENT_MESSAGE_HANDLER(ClassName, Function)	LRESULT ClassName::Function(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
#define	IMPLEMENT_COMMAND_HANDLER(ClassName, Function)	LRESULT ClassName::Function(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL &bHandled)
#define	IMPLEMENT_NOTIFY_HANDLER(ClassName, Function)	LRESULT ClassName::##Function(int nCtrlId, NMHDR *pNMHdr, BOOL &bHandled)

inline void FillSolidRect(HDC hDC, int x, int y, int cx, int cy, COLORREF clr)
{
	/*
	COLORREF oldColor = ::SetBkColor(hDC, clr);
	RECT rect;
	rect.left = x;
	rect.top = y;
	rect.right = x + cx;
	rect.bottom = y + cy;
	::ExtTextOut(hDC, 0, 0, ETO_OPAQUE, &rect, NULL, 0, NULL);
	::SetBkColor(hDC, oldColor);
	*/
	Gdiplus::Graphics g(hDC);
	Gdiplus::SolidBrush brush(Gdiplus::Color(0xff, GetRValue(clr), GetGValue(clr), GetBValue(clr)));
	g.FillRectangle(&brush, x, y, cx, cy);
}
inline void FillSolidRect(HDC hDC, LPRECT pRect, COLORREF clr)
{
	FillSolidRect(hDC, pRect->left, pRect->top, abs(pRect->right-pRect->left), abs(pRect->bottom-pRect->top), clr);
}
inline void DrawFrame(HDC hDC, int x, int y, int cx, int cy, COLORREF clr, int nThickness)
{
	/*
	COLORREF oldPenClr = SetDCPenColor(hDC, clr);
	HPEN hPen = (HPEN)GetStockObject(DC_PEN);
	HGDIOBJ oldPen = SelectObject(hDC, hPen);
	HBRUSH hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	HGDIOBJ oldBrush = SelectObject(hDC, hBrush);
	Rectangle(hDC, x, y, x+cx, y+cy);
	SelectObject(hDC, oldBrush);
	SelectObject(hDC, oldPen);
	SetDCPenColor(hDC, oldPenClr);
	*/
	Gdiplus::Graphics g(hDC);
	Gdiplus::Pen pen(Gdiplus::Color(0xff, GetRValue(clr), GetGValue(clr), GetBValue(clr)), Gdiplus::REAL(nThickness));
	g.DrawRectangle(&pen, x, y, cx, cy);

}